//GenererChiffres_501f.js
// 17.04.2018 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Crer une colonne de chiffres

// activer l'affichage des dialogues ///////////////////////////////////////////////
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert ////////////////////////////////////////////////
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}
else {
	curDoc = app.documents[0];
}

// initialiser la liste des blocs de texte
var txtFrameArr = [];

// mmoriser et tester la slection
var nTxtFrames = 0;
curSel = app.selection;

if (curSel.length > 0) {
	for (var s=0; s<curSel.length; s++) {
		var curType = curSel[s].constructor.name;
		if (curType == "TextFrame") {
			txtFrameArr.push(curSel[s]);
		}
		else if (curType == "Group") {
			var allItems = curSel[s].allPageItems;
			for (var n=0; n<allItems.length; n++) {
				var curType = allItems[n].constructor.name;
				if (curType == "TextFrame") {
					txtFrameArr.push(allItems[n]);
				}
			}
		}
		else {
			if (curSel[0].hasOwnProperty("baseline")) {
				txtFrameArr.push(curSel[0].parentTextFrames[0]);
			}
		}
	}
	nTxtFrames = txtFrameArr.length;
	if (nTxtFrames == 0) {
		alert ("La slection ne contient pas de bloc texte.", "Stop");
		exit();
	}
}
else {
	alert ("Slectionner un bloc texte vide.", "Stop");
	exit();
}

// vrifier le rsultat ////////////////////////////////////////////////////////////
if (nTxtFrames > 1) { // plusieurs blocs texte sont slectionns
	alert ("Ne slectionner qu'un seul bloc texte.", "Attention");
	exit();
}
else if (nTxtFrames == 1) {
	var curFrame = txtFrameArr[0];
	var curCont  = curFrame.parentStory.contents;
	if (curCont.length == 0) { // le bloc texte est vide (= okay)
		// appeler la fonction qui lit les prfrences enregistres
		var defStr = getPrefs();
		// le fichier existe: extraire les valeurs
		if (defStr != "") {
			repDef = defStr.split("\n");
			stVal = repDef[0]*1;
			ndVal = repDef[1]*1;
			tyDec = repDef[2];
			rb01 = rb02 = 0;
			if (tyDec == "0") {
				rb01 = 1;
			}
			else if (tyDec == "1") {
				rb02 = 1;
			}
			ssDec = repDef[3];
			rb03 = rb04 = 0;
			if (ssDec == "0") {
				rb03 = 1;
			}
			else if (ssDec == "1") {
				rb04 = 1;
			}
			diDec = repDef[4];
			rb05 = rb06 = 0;
			if (diDec == "0") {
				rb05 = 1;
			}
			else if (diDec == "1") {
				rb06 = 1;
			}
			zeDec = repDef[5];
			rb07 = rb08 = 0;
			if (zeDec == "0") {
				rb07 = 1;
			}
			else if (zeDec == "1") {
				rb08 = 1;
			}
			adDec = repDef[6];
			rb09 = rb10 = rb11 = rb12 = 0;
			if (adDec == "0") {
				rb09 = 1;
			}
			else if (adDec == "1") {
				rb10 = 1;
			}
			else if (adDec == "2") {
				rb11 = 1;
			}
			else if (adDec == "3") {
				rb12 = 1;
			}
		}
		else { // sinon, utiliser ces valeurs de base
			stVal =  1;
			ndVal = 10;
			rb01  =  1;
			rb02  =  0;
			rb03  =  1;
			rb04  =  0;
			rb05  =  1;
			rb06  =  0;
			rb07  =  1;
			rb08  =  0;
			rb09  =  1;
			rb10  =  0;
			rb11  =  0;
			rb12  =  0;
		}
		
		// appeler la fonction pour demander les valeurs (premire et dernire, etc.)
		var defNumbers = getNumbers();
		var startVal   = defNumbers[0];
		var stopVal    = defNumbers[1];
		var typeDec    = defNumbers[2];
		var chfrDec    = defNumbers[3];
		var direDec    = defNumbers[4];
		var zeroDec    = defNumbers[5];
		var addiDec    = defNumbers[6];
		
		// les listes des chanes de texte partiels ////////////////////////////////////////
		if (chfrDec == 0) { // quand "CH" est slectionn
			oneStrings = ["zro", "un", "deux", "trois", "quatre", "cinq", "six", "sept", "huit", "neuf"];
			dblStrings = ["", "", "", "", "", "", "", "", "", "", "dix", "onze", "douze", "treize", "quatorze", "quinze", "seize", "dix-sept", "dix-huit", "dix-neuf"];
			tenStrings = ["", "dix", "vingt", "trente", "quarante", "cinquante", "soixante", "septante", "huitante", "nonante"];
		}
		else { // l'criture des chiffres  la franaise 
			oneStrings = ["zro", "un", "deux", "trois", "quatre", "cinq", "six", "sept", "huit", "neuf"];
			dblStrings = ["", "", "", "", "", "", "", "", "", "", "dix", "onze", "douze", "treize", "quatorze", "quinze", "seize", "dix-sept", "dix-huit", "dix-neuf"];
			tenStrings = ["", "dix", "vingt", "trente", "quarante", "cinquante", "soixante"];
		}
		
		// quelques tests
		if (typeDec == 0) { // = en lettres
			if (startVal < 0 || stopVal < 0) { // = des valeurs ngatives
				alert ("Des mots ngatifs ne sont pas possibles.", "Stop");
				exit();
			}
		}
		else if (typeDec == 1) { // = en chiffres
			if (zeroDec == 1) {
				if (startVal > -1 && stopVal > -1) {
					var nStart = (""+startVal).length;
					var nStop  = (""+stopVal).length; 
					if (nStart != nStop) {
						if (nStop > nStart) {
							nDiff = nStop-nStart;
						}
						else {
							nDiff = nStart-nStop;
						}
					}
					else {
						zeroDec = 0;
					}
				}
				else {
					var startTmp = startVal;
					if (startVal < 0) {
						startTmp = startVal-(startVal*2);
					}
					var stopTmp  = stopVal;
					if (stopVal < 0) {
						stopTmp = stopVal-(stopVal*2);
					}
					if (startTmp<stopTmp) {
						startTmp = stopTmp;
					}
					var nStart = (""+startTmp).length;
					var nStop  = 1;
					nDiff = nStart-nStop;
				}
			}
			if (addiDec == 2 || addiDec == 3) {
				var minusChar = "";
			}
			if (startVal < 0 || stopVal < 0) {
				var minusChar = "";
				app.findTextPreferences = app.changeTextPreferences = null;
				app.findTextPreferences.findWhat   = "-";
				app.changeTextPreferences.changeTo = "";
			}
			if (minusChar == "") {
				if (direDec == 0) {
					direDec = 1;
				}
				else if (direDec == 1) {
					direDec = 0;
				}
			}
		}
		
		// annuler la slection
		app.selection = null;
		var numArr = [];
		var ctr = 0;
		// une boucle  travers les valeurs
		if (direDec == 0) { // quand ascendant
			if (typeDec == 0) { // = en lettres
				for (var n=startVal; n<stopVal+1; n++) {
					numberText = getNumberText(""+n, chfrDec);
					if (numberText != undefined) {
						numArr[ctr] = numberText;
						ctr++;
					}
				}
				var numStr = numArr.join("\r");
				curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
			}
			else { // = en chiffres
				if (addiDec == 0) { // sans adjonction
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 1) { // insrer un tabulateur
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = "\t"+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 2) { // insrer un signe "moins"
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 3) { // insrer un tabulateur et un signe "moins"
					for (var n=startVal; n<stopVal+1; n++) {
						numArr[ctr] = "\t"+minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4";
							curFrame.parentStory.changeGrep();
						}
					}
				}
			}
		}
		else if (direDec == 1) { // quand dscendant
			if (typeDec == 0) { // = en lettres
				for (var n=stopVal; n>=startVal; n--) {
					numberText = getNumberText(""+n, chfrDec);
					if (numberText != undefined) {
						numArr[ctr] = numberText;
						ctr++;
					}
				}
				var numStr = numArr.join("\r");
				curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
			}
			else { // = en chiffres
				if (addiDec == 0) { // sans adjonction
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 1) { //  insrer un tabulateur
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = "\t"+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 2) { // insrer un signe "moins"
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3";
							curFrame.parentStory.changeGrep();
						}
					}
				}
				else if (addiDec == 3) { // insrer un tabulateur et un signe "moins"
					for (var n=stopVal; n>=startVal; n--) {
						numArr[ctr] = "\t"+minusChar+n;
						ctr++;
					}
					var numStr = numArr.join("\r");
					curFrame.parentStory.insertionPoints.item(-1).contents = numStr;
					if (zeroDec == 1) {
						app.findGrepPreferences = app.changeGrepPreferences = null;
						var zeroPad = "";
						for (var d=nDiff; d>0; d--) {
							zeroPad += "0";
							app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+d+"})$";
							app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4";
							curFrame.parentStory.changeGrep();
						}
					}
				}
			}
		}
		if (minusChar == "") {
			curFrame.parentStory.changeText();
		}
		if (zeroDec == 1) {
			curFrame.parentStory.recompose();
		}
	}
	else {
		alert ("Le bloc texte doit tre vide.", "Stop");
		exit();
	}
}

//rtablir les prfrences rechercher/remplacer ////////////////////////////////////
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// annoncer la fin de l'action /////////////////////////////////////////////////////
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(444);
// fermer le dialogue
dlog.close();


////////////////////////////////////////////////////////////////////////////////////
// prparer les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Chiffres_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Chiffres_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// afficher un dialogue (premire valeur, dernire valeur, etc.) ///////////////////
function getNumbers() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth1 = 138;
	var labelWidth2 = 104;
	var fieldWidth1 =  64;
	var bttnsWidth1 = 124;
	var aDialog = app.dialogs.add({name:"Colonne de valeurs en lettres (ou en chiffres)"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Premire valeur ", minWidth:labelWidth1});
				var startField = integerEditboxes.add({editValue:stVal, minWidth:fieldWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Dernire valeur ", minWidth:labelWidth1});
				var stopField = integerEditboxes.add({editValue:ndVal, minWidth:fieldWidth1});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Le genre ", minWidth:labelWidth2});
						with(typButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" en lettres", checkedState:rb01, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" en chiffres", checkedState:rb02});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"\"CH\" ou \"F\" ", minWidth:labelWidth2});
						with(essButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" septante", checkedState:rb03, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" soixante-dix", checkedState:rb04});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"La direction ", minWidth:labelWidth2});
						with(dirButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" ascendant", checkedState:rb05, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" descendant", checkedState:rb06});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:20});
				staticTexts.add({staticLabel:"Quand \"chiffres\"..."});
				staticTexts.add({staticLabel:" ", minWidth:2});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Zros de dbut", minWidth:labelWidth2});
						with(zerButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" non", checkedState:rb07, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" oui", checkedState:rb08});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Insrer devant", minWidth:labelWidth2});
						with(addButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" rien", checkedState:rb09, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" tabulateur", checkedState:rb10});
							radiobuttonControls.add({staticLabel:" signe moins", checkedState:rb11});
							radiobuttonControls.add({staticLabel:" tab et moins", checkedState:rb12});
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"", minWidth:0});
			}
		}

	}
	// afficher le dialogue
	if(aDialog.show() == true) {
		var startVal = startField.editValue;
		var stopVal  = stopField.editValue;
		var typDec   = typButtns.selectedButton;
		var essDec   = essButtns.selectedButton;
		var dirDec   = dirButtns.selectedButton;
		var zerDec   = zerButtns.selectedButton;
		var addDec   = addButtns.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		// la liste des rglages...
		var prefsList = new Array(startVal, stopVal, typDec, essDec, dirDec, zerDec, addDec);
		// ... la convertir en chane de texte ...
		var curDef = prefsList.join("\n");
		// ... appeler la fonction qui crit la chane dans un fichier
		writeResult(curDef);
		// renvoyer le rsultat  l'appel
		if (startVal<stopVal) {
			return [startVal, stopVal, typDec, essDec, dirDec, zerDec, addDec];
		}
		else {
			return [stopVal, startVal, typDec, essDec, dirDec, zerDec, addDec];
		}
	}
	else {
		aDialog.destroy();
		exit();
	}
}

////////////////////////////////////////////////////////////////////////////////////
// crire le rsultat dans un fichier //////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Chiffres_501.txt");
	}
	else {
		var f = File("~/Library/Preferences/Chiffres_501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////
// la fonction qui convertit les chiffres en texte /////////////////////////////////
function getNumberText(nStr, chfrDec) {
	if (isNaN(nStr)) {
		alert ("Ce script ne fonctionne qu'avec des chiffres arabes.", "Attention");
		app.findGrepPreferences = app.changeGrepPreferences = null;
		app.findTextPreferences = app.changeTextPreferences = null;
		exit();
	}
	var strLen = nStr.length;
	var numVal = nStr*1;
	// le choix est "Suisse"
	if (chfrDec == 0) {
		if (strLen == 1) {
			if (numVal == 1) {
				return "un";
			}
			else {
				return (oneStrings[numVal]);
			}
		}
		else if (strLen == 2) {
			if (numVal < 20) {
				return (dblStrings[numVal]);
			}
			else if (numVal > 19) {
				if (nStr[1] == "0") {
					return tenStrings[nStr[0]*1];
				}
				else if (nStr[1] == "1") {
					return (tenStrings[nStr[0]*1])+" et un";
				}
				else {
					return (tenStrings[nStr[0]*1])+"-"+(oneStrings[nStr[1]*1]);
				}
			}
		}
		else if (strLen == 3) {
			var d1 = nStr[0];
			var d2 = nStr[1];
			var d3 = nStr[2];
			if (d2 == 0 && d3 == 0) { // 100
				if (d1 == "1") {
					return "cent";
				}
				else {
					return (oneStrings[d1])+" cents";
				}
			}
			else if (d2 == 0 && d3 == 1) { // 101 {
				if (d1 == "1") {
					return "cent un";
				}
				else {
					return (oneStrings[d1]+" cent un");
				}
			}
			else if (d2 == 0 && d3 > 1) { // 102, etc.
				if (d1 == "1") {
					return ("cent "+oneStrings[d3]);
				}
				else {
					return (oneStrings[d1]+" cent "+oneStrings[d3]);
				}
			}
			else if (d2 > 0 && d3 == 0) { // 110, etc.
				if (d1 == "1") {
					return ("cent "+tenStrings[d2]);
				}
				else {
					return (oneStrings[d1]+" cent "+tenStrings[d2]);
				}
			}
			else if (d2 == 1 && d3 > 0) { // 111, etc.
				if (d1 == "1") {
					return ("cent "+dblStrings[(d2+d3)]);
				}
				else {
					return (oneStrings[d1]+" cent "+dblStrings[(d2+d3)]);
				}
			}
			else if (d2 > 1 && d3 > 0) { // 121, etc.
				if (d1 == "1") {
					if (d3 == "1") {
						return ("cent "+tenStrings[d2]+" et un");
					}
					else {
						return ("cent "+tenStrings[d2]+"-"+oneStrings[d3]);
					}
				}
				else {
					if (d3 == "1") {
						return (oneStrings[d1]+" cent "+tenStrings[d2]+" et un");
					}
					else {
						return (oneStrings[d1]+" cent "+tenStrings[d2]+"-"+oneStrings[d3]);
					}
				}
			}
		}
		else if (strLen == 4) {
			if (nStr == 1000) {
				return "mille";
			}
			else {
				alert ("Ce script ne peut pas convertir des valeurs  partir de 1001.", "Attention");
				app.findGrepPreferences = app.changeGrepPreferences = null;
				app.findTextPreferences = app.changeTextPreferences = null;
				exit();
			}
		}
	}
	else { // le choix est "France"
		if (strLen == 1) {
			if (numVal == 1) {
				return "une";
			}
			else {
				return (oneStrings[numVal]);
			}
		}
		else if (strLen == 2) {
			if (numVal < 20) {
				return (dblStrings[numVal]);
			}
			else if (numVal > 19) {
				if (nStr[0]*1 < 7) {
					if (nStr[1] == "0") {
						return tenStrings[nStr[0]*1];
					}
					else if (nStr[1] == "1") {
						return (tenStrings[nStr[0]*1])+" et un";
					}
					else {
						return (tenStrings[nStr[0]*1])+"-"+(oneStrings[nStr[1]*1]);
					}
				}
				else {
					if (nStr[0] == "7") {
						if (nStr[1] == "0") {
							return "soixante-dix";
						}
						else {
							return "soixante-"+(dblStrings[nStr[1]*1+10]);
						}
					}
					else if (nStr[0] == "8") {
						if (nStr[1] == "0") {
							return "quatre-vingts";
						}
						else {
							return "quatre-vingt-"+(oneStrings[nStr[1]*1]);
						}
					}
					else if (nStr[0] == "9") {
						if (nStr[1] == "0") {
							return "quatre-vingt-dix";
						}
						else {
							return "quatre-vingt-"+(dblStrings[nStr[1]*1+10]);
						}
					}
				}
			}
		}
		else if (strLen == 3) {
			var rstVal = numVal % 100;
			if (rstVal == 0) {
				if (nStr[0] == "1") {
					return "cent";
				}
				else {
					return (oneStrings[nStr[0]*1])+" cents";
				}
			}
			else if (rstVal == 1) {
				if (nStr[0] == "1") {
					return "cent un";
				}
				else {
					return (oneStrings[nStr[0]*1])+" cent un";
				}
			}
			else if (rstVal < 10) {
				if (nStr[0] == "1") {
					return "cent "+(oneStrings[(nStr[2]*1)]);
				}
				else {
					return (oneStrings[nStr[0]*1])+" cent "+(oneStrings[(nStr[2]*1)]);
				}
			}
			else if (rstVal < 20) {
				if (nStr[0] == "1") {
					return "cent "+(dblStrings[(nStr[1]+nStr[2])*1]);
				}
				else {
					return (oneStrings[nStr[0]*1])+" cent "+(dblStrings[(nStr[1]+nStr[2])*1]);
				}
			}
			else if (rstVal > 19) {
				if (nStr[1]*1 < 7) {
					if (nStr[0] == "1") {
						if (nStr[2] == "0") {
							return "cent "+tenStrings[nStr[1]*1];
						}
						else if (nStr[2] == "1") {
							return "cent "+(tenStrings[nStr[1]*1])+" et un";
						}
						else {
							return "cent "+(tenStrings[nStr[1]*1])+"-"+(oneStrings[nStr[2]*1]);
						}
					}
					else {
						if (nStr[2] == "0") {
							return (oneStrings[nStr[0]*1])+" cent "+tenStrings[nStr[1]*1];
						}
						else if (nStr[2] == "1") {
							return (oneStrings[nStr[0]*1])+" cent "+(tenStrings[nStr[1]*1])+" et un";
						}
						else {
							return (oneStrings[nStr[0]*1])+" cent "+(tenStrings[nStr[1]*1])+"-"+(oneStrings[nStr[2]*1]);
						}
					}
				}
				else {
					if (nStr[1] == "7") {
						if (nStr[2] == "0") {
							if (nStr[0] == "1") {
								return "cent "+"soixante-dix";
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"soixante-dix";
							}
						}
						else {
							if (nStr[0] == "1") {
								return "cent "+"soixante-"+(dblStrings[nStr[2]*1+10]);
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"soixante-"+(dblStrings[nStr[2]*1+10]);
							}
						}
					}
					else if (nStr[1] == "8") {
						if (nStr[2] == "0") {
							if (nStr[0] == "1") {
								return "cent "+"quatre-vingts";
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"quatre-vingts";
							}
						}
						else {
							if (nStr[0] == "1") {
								return "cent "+"quatre-vingt-"+(oneStrings[nStr[2]*1]);
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"quatre-vingt-"+(oneStrings[nStr[2]*1]);
							}
						}
					}
					else if (nStr[1] == "9") {
						if (nStr[2] == "0") {
							if (nStr[0] == "1") {
								return "cent "+"quatre-vingt-dix";
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"quatre-vingt-dix";
							}
						}
						else {
							if (nStr[0] == "1") {
								return "cent "+"quatre-vingt-"+(dblStrings[nStr[2]*1+10]);
							}
							else {
								return (oneStrings[nStr[0]*1])+" cent "+"quatre-vingt-"+(dblStrings[nStr[2]*1+10]);
							}
						}
					}
				}
			}
		}
		else if (strLen == 4) {
			if (nStr == 1000) {
				return "mille";
			}
			else {
				alert ("Ce script ne peut pas convertir des valeurs  partir de 1001.", "Attention");
				app.findGrepPreferences = app.changeGrepPreferences = null;
				app.findTextPreferences = app.changeTextPreferences = null;
				exit();
			}
		}
	}
}